Index: trunk/kernel/Makefile
===================================================================
--- trunk/kernel/Makefile	(revision 690)
+++ trunk/kernel/Makefile	(revision 1)
@@ -1,313 +1,100 @@
-#############################################################################
-#                  ALMOS-MKH  Makefile for Kernel                           #
-#############################################################################
+#=====================================================================
+#                      ALMOS-kernel Makefile                         #
+#=====================================================================
 
--include ../params-soft.mk
-ifeq ($(ARCH_NAME),)
-$(error Please define in ARCH_NAME parameter in params-soft.mk!)
+include ../common.mk
+
+KERNEL_REV ?=current
+
+DIRS=	cpu/$(CPU)           	  \
+	arch/$(ARCH)         	  \
+	drivers/$(DRVRS)	  \
+	kern                      \
+	mm                        \
+	fs/devfs                  \
+	fs/sysfs                  \
+	fs/ext2                   \
+	fs/fat32                  \
+	fs/ramfs                  \
+	vfs                       \
+	libk                      \
+	ksh
+
+ifndef CPU
+$(error CPU variable is not defined)
 endif
 
-# We choose drivers and hal file to be linked with kernel.elf
-ifeq ($(ARCH_NAME), tsar_mips32)
+LFLAGS = -T$(OBJDIR)/kldscript $(CPULFLAGS)
 
-  DRIVERS_OBJS = $(HAL_ARCH)/build/drivers/soclib_tty.o  \
-                 $(HAL_ARCH)/build/drivers/soclib_mty.o  \
-                 $(HAL_ARCH)/build/drivers/soclib_bdv.o  \
-                 $(HAL_ARCH)/build/drivers/soclib_hba.o  \
-                 $(HAL_ARCH)/build/drivers/soclib_mmc.o  \
-                 $(HAL_ARCH)/build/drivers/soclib_pic.o  \
-                 $(HAL_ARCH)/build/drivers/soclib_nic.o  \
-                 $(HAL_ARCH)/build/drivers/soclib_dma.o  \
-                 $(HAL_ARCH)/build/drivers/soclib_fbf.o  \
-                 $(HAL_ARCH)/build/drivers/soclib_iob.o
+INCLUDES=	$(foreach DIR,$(DIRS),-I$(DIR)) -I$(OBJDIR)/kern/
 
-  HAL_OBJS     = $(HAL_ARCH)/build/core/hal_special.o    \
-                 $(HAL_ARCH)/build/core/hal_context.o    \
-                 $(HAL_ARCH)/build/core/hal_atomic.o     \
-                 $(HAL_ARCH)/build/core/hal_remote.o     \
-                 $(HAL_ARCH)/build/core/hal_uspace.o     \
-                 $(HAL_ARCH)/build/core/hal_irqmask.o    \
-                 $(HAL_ARCH)/build/core/hal_gpt.o        \
-                 $(HAL_ARCH)/build/core/hal_ppm.o        \
-                 $(HAL_ARCH)/build/core/hal_vmm.o        \
-                 $(HAL_ARCH)/build/core/hal_kentry.o     \
-                 $(HAL_ARCH)/build/core/hal_switch.o     \
-                 $(HAL_ARCH)/build/core/hal_syscall.o    \
-                 $(HAL_ARCH)/build/core/hal_exception.o  \
-                 $(HAL_ARCH)/build/core/hal_interrupt.o  \
-                 $(HAL_ARCH)/build/core/hal_drivers.o
+CFLAGS  = 	$(INCLUDES) -fno-builtin -static -Wall -Werror -MMD -Wundef
+ifeq   ($(MODE),DEBUG)
+CFLAGS  += 	-g -O0 -fno-inline
+else
+CFLAGS  += 	-O2 
+endif
+CFLAGS +=	$(CPUCFLAGS)
+
+CFILES=	$(foreach DIR,$(DIRS),$(wildcard $(DIR)/*.c))
+SFILES=	$(wildcard cpu/$(CPU)/*.S)
+
+OBJS=	$(addprefix $(OBJDIR)/, $(CFILES:.c=.o) $(SFILES:.S=.o))
+DEPS=	$(OBJS:.o=.d)
+
+OBJDIRS= $(addprefix $(OBJDIR)/, $(DIRS))
+
+# Kernel bin file name
+ifeq ($(KERNEL_REV),current)
+TARGET=$(OBJDIR)/almos-mk-$(ARCH)-$(CPU)
+else
+TARGET=$(OBJDIR)/almos-mk-$(ARCH)-$(CPU)-$(KERNEL_REV)
 endif
 
-ifeq ($(ARCH_NAME), x86_64)
 
-  DRIVERS_OBJS = $(HAL_ARCH)/build/drivers/ioc_ata.o     \
-                 $(HAL_ARCH)/build/drivers/pic_apic.o    \
-                 $(HAL_ARCH)/build/drivers/txt_rs232.o
+.PHONY: clean timestamp
 
-  HAL_OBJS     = $(HAL_ARCH)/build/core/hal_boot.o       \
-                 $(HAL_ARCH)/build/core/hal_smpboot.o    \
-                 $(HAL_ARCH)/build/core/hal_init.o       \
-                 $(HAL_ARCH)/build/core/hal_cpu.o        \
-                 $(HAL_ARCH)/build/core/hal_kentry.o     \
-                 $(HAL_ARCH)/build/core/hal_acpi.o       \
-                 $(HAL_ARCH)/build/core/hal_apic.o       \
-                 $(HAL_ARCH)/build/core/x86_printf.o     \
-                 $(HAL_ARCH)/build/core/hal_drivers.o    \
-                 $(HAL_ARCH)/build/core/hal_special.o    \
-                 $(HAL_ARCH)/build/core/hal_context.o    \
-                 $(HAL_ARCH)/build/core/hal_atomic.o     \
-                 $(HAL_ARCH)/build/core/hal_remote.o     \
-                 $(HAL_ARCH)/build/core/hal_uspace.o     \
-                 $(HAL_ARCH)/build/core/hal_irqmask.o    \
-                 $(HAL_ARCH)/build/core/hal_gpt.o        \
-                 $(HAL_ARCH)/build/core/hal_ppm.o        \
-                 $(HAL_ARCH)/build/core/hal_exception.o  \
-                 $(HAL_ARCH)/build/core/hal_interrupt.o  \
-                 $(HAL_ARCH)/build/core/hal_syscall.o
+
+$(TARGET): $(OBJDIRS) $(OBJDIR)/kldscript timestamp $(OBJS) 
+	@echo '   [  LD  ]        '$@.elf
+	@$(LD) -o $@.elf $(OBJS) $(LFLAGS)
+	@echo '   [  NM  ]        '$@.elf.nm 
+	@$(NM) $@.elf > $@.elf.nm
+	@echo '   [ COPY ]        '$@.bin
+	@$(OCPY) -O binary  $@.elf  $@.bin
+	@echo -e '\n   [ DONE ]        \n'
+	$(ODMP) $(DUMPFLAGS)  -d $@.elf > $@.dump
+
+
+timestamp:
+	@echo "Compile flags: $(CFLAGS)"
+	@echo '#define ALMOS_DATE "'$(shell date +"%d %B %Y - %T")'"' > $(OBJDIR)/kern/almOS-date.h 
+
+$(OBJDIR)/kldscript: arch/$(ARCH)/kldscript.h arch/$(ARCH)/arch-config.h
+	@echo '   [  CPP ]        '$< 
+	@cpp $< | grep -v "#" | grep . > $@
+
+$(OBJDIR)/%.o: %.c
+	@echo '   [  CC  ]        '$<
+	cpp $(INCLUDES) $< out.cpp
+	@$(CC) $(CFLAGS) -c $< -o $@
+ifneq   ($(MODE),DEBUG)
+	@$(STRIP) -x -R .pdr -R .gnu.attributes -R .reginfo -R .comment $@
 endif
 
-LIBGCC = -L$(shell $(CC) -print-libgcc-file-name | sed 's/libgcc.a//') #todo ?
+$(OBJDIR)/%.o: %.S
+	@echo '   [  AS  ]        '$<
+	@$(CC) $(CFLAGS) -c $< -o $@
+ifneq   ($(MODE),DEBUG)
+	@$(STRIP) -x -R .pdr -R .gnu.attributes -R .reginfo -R .comment $@
+endif
 
-# Rules that don't build target files
-# always out-of-date, need to be regenerated everytime they are called
-.PHONY: compile			        \
-		dirs				    \
-		clean				    \
-		build/kernel.elf
+clean:
+	rm -rf $(OBJDIR) out.cpp
+
+$(OBJDIRS):
+	@echo '   [ MKDIR ]       '$@
+	@mkdir -p $@
 
 
-# Objects to be linked for kernel.elf generation
-KERN_OBJS	= build/kern/kernel_init.o      \
-              build/kern/printk.o           \
-              build/kern/thread.o           \
-              build/kern/process.o          \
-              build/kern/chdev.o            \
-              build/kern/ksocket.o          \
-              build/kern/cluster.o          \
-              build/kern/scheduler.o        \
-              build/kern/core.o             \
-              build/kern/dqdt.o             \
-              build/kern/do_syscall.o       \
-              build/kern/rpc.o              \
-              build/kern/alarm.o            \
-              build/kern/pipe.o
-
-DEV_OBJS    = build/devices/dev_txt.o       \
-              build/devices/dev_ioc.o       \
-              build/devices/dev_mmc.o       \
-              build/devices/dev_nic.o       \
-              build/devices/dev_pic.o       \
-              build/devices/dev_dma.o       \
-              build/devices/dev_fbf.o       \
-              build/devices/dev_iob.o
-
-MM_OBJS     = build/mm/ppm.o                \
-              build/mm/vmm.o                \
-              build/mm/vseg.o               \
-              build/mm/page.o               \
-              build/mm/kcm.o                \
-              build/mm/mapper.o             \
-              build/mm/kmem.o
-
-LIBK_OBJS   = build/libk/grdxt.o            \
-              build/libk/bits.o             \
-              build/libk/elf.o              \
-              build/libk/string.o           \
-              build/libk/ctype.o            \
-              build/libk/rwlock.o           \
-              build/libk/busylock.o         \
-              build/libk/queuelock.o        \
-              build/libk/barrier.o          \
-              build/libk/xbarrier.o         \
-              build/libk/remote_busylock.o  \
-              build/libk/remote_queuelock.o \
-              build/libk/remote_rwlock.o    \
-              build/libk/remote_fifo.o      \
-              build/libk/remote_mutex.o     \
-              build/libk/remote_sem.o       \
-              build/libk/remote_condvar.o   \
-              build/libk/remote_barrier.o   \
-              build/libk/remote_buf.o       \
-              build/libk/memcpy.o           \
-              build/libk/htab.o             \
-              build/libk/xhtab.o            \
-              build/libk/user_dir.o
-
-SYS_OBJS_0  = build/syscalls/sys_thread_exit.o     \
-              build/syscalls/sys_thread_yield.o    \
-              build/syscalls/sys_thread_create.o   \
-              build/syscalls/sys_thread_join.o     \
-              build/syscalls/sys_thread_detach.o   \
-              build/syscalls/sys_thread_cancel.o   \
-              build/syscalls/sys_sem.o             \
-              build/syscalls/sys_condvar.o         \
-              build/syscalls/sys_barrier.o         \
-              build/syscalls/sys_mutex.o 
-
-SYS_OBJS_1  = build/syscalls/sys_rename.o          \
-              build/syscalls/sys_munmap.o          \
-              build/syscalls/sys_open.o            \
-              build/syscalls/sys_mmap.o            \
-              build/syscalls/sys_read.o            \
-              build/syscalls/sys_write.o           \
-              build/syscalls/sys_lseek.o           \
-              build/syscalls/sys_close.o           \
-              build/syscalls/sys_unlink.o          \
-              build/syscalls/sys_pipe.o
-
-SYS_OBJS_2  = build/syscalls/sys_chdir.o           \
-              build/syscalls/sys_mkdir.o           \
-              build/syscalls/sys_mkfifo.o          \
-              build/syscalls/sys_opendir.o         \
-              build/syscalls/sys_readdir.o         \
-              build/syscalls/sys_closedir.o        \
-              build/syscalls/sys_getcwd.o          \
-              build/syscalls/sys_isatty.o          \
-              build/syscalls/sys_alarm.o           \
-              build/syscalls/sys_rmdir.o
-
-SYS_OBJS_3  = build/syscalls/sys_utls.o            \
-              build/syscalls/sys_chmod.o           \
-              build/syscalls/sys_signal.o          \
-              build/syscalls/sys_timeofday.o       \
-              build/syscalls/sys_kill.o            \
-              build/syscalls/sys_getpid.o          \
-              build/syscalls/sys_fork.o            \
-              build/syscalls/sys_exec.o            \
-              build/syscalls/sys_stat.o            \
-              build/syscalls/sys_wait.o 
-
-SYS_OBJS_4  = build/syscalls/sys_get.o             \
-              build/syscalls/sys_display.o         \
-              build/syscalls/sys_place_fork.o      \
-              build/syscalls/sys_thread_sleep.o    \
-              build/syscalls/sys_thread_wakeup.o   \
-              build/syscalls/sys_trace.o           \
-              build/syscalls/sys_fg.o              \
-              build/syscalls/sys_is_fg.o           \
-              build/syscalls/sys_fbf.o
-
-SYS_OBJS_5  = build/syscalls/sys_exit.o            \
-              build/syscalls/sys_sync.o            \
-              build/syscalls/sys_fsync.o           \
-              build/syscalls/sys_socket.o
-
-VFS_OBJS    = build/fs/vfs.o              \
-              build/fs/fatfs.o            \
-              build/fs/devfs.o            \
-              build/fs/ramfs.o
-
-# List of directories to be searched for included files
-# when compiling for kernel.elf generation
-KERNEL_INCLUDE = -I.                   \
-                 -Ikern                \
-                 -Idevices             \
-                 -Isyscalls            \
-                 -I$(SHARED_INCLUDE)   \
-                 -I$(HAL_ARCH)/drivers \
-                 -Isyscalls            \
-                 -Ilibk                \
-                 -Imm                  \
-                 -Ifs                  \
-                 -I../tools/arch_info  \
-                 -I$(HAL)/generic      \
-                 -I$(HAL_ARCH)/core    \
-                 -I..
-
-# Rule to generate kernel.elf.
-compile: dirs                     \
-         build/kernel.elf
-
-# Rule to create the build directories.
-dirs:
-	@mkdir -p build
-	@mkdir -p build/kern
-	@mkdir -p build/hal
-	@mkdir -p build/devices
-	@mkdir -p build/mm
-	@mkdir -p build/libk
-	@mkdir -p build/drivers
-	@mkdir -p build/fs
-	@mkdir -p build/syscalls
-
-
-######################################
-# rules to compile the drivers and hal
-$(HAL_ARCH)/build/%:
-	$(MAKE) -C $(HAL_ARCH)
-
-#######################################
-# Rules to generate kernel/kern objects
-build/kern/%.o:		    kern/%.c                      \
-                        kern/%.h                      \
-                        kernel_config.h               \
-                        $(HAL_ARCH)/core/hal_kernel_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-
-
-######################################
-# Rules to generate kernel/dev objects
-build/devices/%.o:      devices/%.c                   \
-                        devices/%.h                   \
-                        kernel_config.h               \
-                        $(HAL_ARCH)/core/hal_kernel_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-
-#####################################
-# Rules to generate kernel/mm objects
-build/mm/%.o:           mm/%.c                        \
-                        mm/%.h                        \
-                        kernel_config.h               \
-                        $(HAL_ARCH)/core/hal_kernel_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-
-#######################################
-# Rules to generate kernel/libk objects
-build/libk/%.o:         libk/%.c                      \
-                        libk/%.h                      \
-                        kernel_config.h               \
-                        $(HAL_ARCH)/core/hal_kernel_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-
-###########################################
-# Rules to generate kernel/syscalls objects
-build/syscalls/%.o:     syscalls/%.c                  \
-                        syscalls/syscalls.h           \
-                        kernel_config.h               \
-                        $(HAL_ARCH)/core/hal_kernel_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-
-#######################################
-# Rules to generate kernel/fs objects
-build/fs/%.o:           fs/%.c                        \
-                        fs/%.h                        \
-                        kernel_config.h               \
-                        $(HAL_ARCH)/core/hal_kernel_types.h
-	$(CC) $(KERNEL_INCLUDE) $(CFLAGS) -c -o $@ $<
-
-##############################
-# Rule to generate kernel.elf
-build/kernel.elf:	$(KERN_OBJS)                 \
-                    $(HAL_OBJS_0)                \
-                    $(HAL_OBJS_1)                \
-                    $(DEV_OBJS)                  \
-                    $(MM_OBJS)                   \
-                    $(LIBK_OBJS)                 \
-                    $(DRIVERS_OBJS)              \
-                    $(VFS_OBJS)                  \
-                    $(SYS_OBJS_0)                \
-                    $(SYS_OBJS_1)                \
-                    $(SYS_OBJS_2)                \
-                    $(SYS_OBJS_3)                \
-                    $(SYS_OBJS_4)                \
-                    $(SYS_OBJS_5)                \
-    	            $(HAL_ARCH)/kernel.ld
-	$(LD) -o $@ -T $(HAL_ARCH)/kernel.ld $(LIBGCC)         \
-          $(KERN_OBJS) $(HAL_OBJS) $(DEV_OBJS) $(MM_OBJS)  \
-          $(LIBK_OBJS) $(DRIVERS_OBJS) $(VFS_OBJS)         \
-          $(SYS_OBJS_0) $(SYS_OBJS_1) $(SYS_OBJS_2)        \
-          $(SYS_OBJS_3) $(SYS_OBJS_4) $(SYS_OBJS_5) -lgcc
-	$(DU) -D $@ > $@.txt
-
-clean:
-	rm -rf build/*
+-include $(DEPS)
Index: trunk/kernel/`
===================================================================
--- trunk/kernel/`	(revision 1)
+++ trunk/kernel/`	(revision 1)
@@ -0,0 +1,264 @@
+/*
+ * rpc.h - RPC related operations
+ *
+ * Authors Mohamed Karaoui (2015)
+ *         Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ * 
+ * This file is part of ALMOS-MK.
+ *
+ * ALMOS-MK is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MK is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MK; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _RPC_H_
+#define _RPC_H_
+
+#include <errno.h>
+#include <types.h>
+#include <bits.h>
+#include <atomic.h>
+#include <spinlock.h>
+#include <remote_fifo.h>
+#include <kernel_config.h>
+
+/**********************************************************************************/
+/**************  structures for Remote Procedure Calls ****************************/
+/**********************************************************************************/
+
+/***********************************************************************************
+ *  This enum defines all RPC indexes (must be consistent with array in rpc.c)
+ **********************************************************************************/
+
+typedef enum
+{
+    RPC_PMEM_GET_PAGES         = 0,
+    RPC_PROCESS_PID_ALLOC      = 1,
+    RPC_PROCESS_MIGRATE        = 2,
+    RPC_THREAD_USER_CREATE     = 3,
+    RPC_VFAT_ALLOC_FAT_ENTRY   = 4,
+    RPC_VFAT_CLUSTER_COUNT     = 5,
+    RPC_VFS_LOOKUP_CHILD       = 6,
+    RPC_MAX_INDEX              = 7
+}
+rpc_index_t;
+
+/***********************************************************************************
+ *  This structure defines the RPC descriptor
+ **********************************************************************************/
+
+typedef struct rpc_desc_s
+{
+	rpc_index_t       index;      // index of requested RPC service
+	volatile uint32_t response;   // response valid when 0
+    uint64_t          args[7];    // input/output arguments buffer
+} 
+rpc_desc_t;
+
+/***********************************************************************************
+ *  This structure defines the RPC fifo, the associated light lock,
+ *  and the intrumentation counter.
+ **********************************************************************************/
+
+typedef struct rpc_fifo_s
+{
+	spinlock_t lock;          // spinlock for the readers
+	uint64_t          count;  // total number of received RPCs (instrumentation) 
+	remote_fifo_t     fifo;   // embedded remote fifo
+} 
+rpc_fifo_t;
+
+
+/**********************************************************************************/
+/******* Generic functions supporting RPCs : client side **************************/
+/**********************************************************************************/
+
+/***********************************************************************************
+ * This blocking function executes on the client core. 
+ * It puts one RPC extended pointer in the remote fifo. 
+ * It sends an IPI if fifo is empty, and waits until RPC response available.
+ * The RPC descriptor must be allocated in the caller's stack
+ * and initialised by the caller.  Exit with a Panic message if remote fifo 
+ * is still full after (CONFIG_RPC_PUT_MAX_ITERATIONS) retries.
+ * @ cxy   : server cluster identifier
+ * @ desc  : local pointer on RPC descriptor in client cluster
+ **********************************************************************************/
+void rpc_send_sync( cxy_t        cxy,    
+                    rpc_desc_t * desc );
+
+/***********************************************************************************
+ * This non blocking function is called by the scheduler of the client core
+ * to detect RPC completion.  
+ * @ ptr   : local pointer on the RPC descriptor in client cluster.
+ * @ return true if the client thread must resume (RPC completed). 
+ **********************************************************************************/ 
+static bool_t rpc_callback( void * ptr );
+
+
+
+/**********************************************************************************/
+/******* Generic functions supporting RPCs : server side **************************/
+/**********************************************************************************/
+
+/***********************************************************************************
+ * This function initialises the local RPC fifo and the lock protecting readers.
+ * The number of slots is defined by the CONFIG_REMOTE_FIFO_SLOTS parameter.
+ * Each slot contains an extended pointer on the RPC descriptor.
+ * @ rf     : pointer on the local RPC fifo.
+ **********************************************************************************/ 
+void rpc_fifo_init( rpc_fifo_t * rf );
+
+/***********************************************************************************
+ * This function is the entry point for RPC handling on the server side.
+ * It can be executed by any thread running (in kernel mode) on any CPU.
+ * It first checks the CPU private RPC fifo, an then the cluster shared RPC fifo.
+ * It calls the rpc_activate_thread() function to activate a dedicated RPC thread,
+ * after registration of the selected RPC fifo in the selected thread descriptor. 
+ * @ returns true if at least one RPC found / false otherwise.
+ **********************************************************************************/
+bool_t rpc_check();
+
+/***********************************************************************************
+ * This function contains the loop to execute all pending RPCs on the server side.
+ * It should be called with irq disabled and after light lock acquisition.
+ * @ rpc_fifo  : pointer on the local RPC fifo
+ * @ returns 0 if success
+ **********************************************************************************/
+error_r rpc_execute_all( rpc_fifo_t * rpc_fifo );
+
+/***********************************************************************************
+ * This function is acting as a demultiplexor on the server side. 
+ * Depending on the RPC index stored in the RPC descriptor,
+ * it calls the relevant rpc_*_server() function.
+ * @ xptr : extended pointer on the RPC descriptor.
+ **********************************************************************************/
+void rpc_handle( xptr_t * xp );
+
+/**********************************************************************************
+ * This function activates one RPC thread to handle the pending RPC(s) contained
+ * in one RPC fifo (shared or private). It is called by any thread detecting
+ * a non-empty RPC fifo.
+ * It gets the first free RPC thread from the free-list, or creates a new one
+ * if the RPC thread free-list associated to the current cpu is empty. 
+ * Finally, the calling thread immediately switches to the RPC thread.
+ * @ rpc_fifo : pointer on the non-empty RPC fifo.
+ * @ return 0 if success / return ENOMEM if error.
+ **********************************************************************************/
+error_t rpc_activate_thread( rpc_fifo_t * rpc_fifo );
+
+/***********************************************************************************
+ * This function defines the infinite loop executed by each RPC thread.
+ **********************************************************************************/
+void * rpc_thread();
+
+/**********************************************************************************
+ * This call-back function must be registered in the RPC thread descriptor.
+ * It is executed by the scheduler when the thread makes a sched_sleep() call,
+ * when the "before_sleep" field in thread descriptor is not NULL. 
+ * It releases the light lock and print a debug message.
+ * @ thread  : local pointer on thread. 
+ **********************************************************************************/
+void rpc_before_sleep( thread_t * thread );
+
+/**********************************************************************************
+ * This call-back function must be registered in the RPC thread descriptor.
+ * It is executed by the scheduler when the thread makes a wakeup(),
+ * when the "after_wakeup" field in thread descriptor is not NULL. 
+ * It print a debug message.
+ * @ thread  : local pointer on thread. 
+ **********************************************************************************/
+void rpc_after_wakeup( thread_t * thread );
+
+/**********************************************************************************/
+/******* Marshalling functions attached to the various RPCs ***********************/
+/**********************************************************************************/
+
+/***********************************************************************************
+ * The RPC_PMEM_GET_PAGES allocates one or several pages in a remote cluster,
+ * and returns the PPN of the first allocated page.
+ * @ cxy     : server cluster identifier
+ * @ order   : [in]  ln2( number of requested pages )
+ * @ status  : [out] error status (0 if success)
+ * @ ppn     : [out] first physical page number
+ **********************************************************************************/
+void rpc_pmem_get_pages_client( cxy_t      cxy,
+                                uint32_t   order,
+                                uint32_t * status,
+                                uint32_t * ppn );
+
+void rpc_pmem_get_pages_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_PROCESS_PID_ALLOC allocates one new PID in a remote cluster, registers
+ * the new process in the remote cluster, and returns the PID, and an error code.
+ * @ cxy     : server cluster identifier.
+ * @ process : [in]  pointer on process descriptor in client cluster.
+ * @ status  : [out] error status (0 if success).
+ * @ pid     : [out] new process identifier.
+ **********************************************************************************/
+void rpc_process_pid_alloc_client( cxy_t       cxy,
+                                   process_t * process,
+                                   error_t   * status,
+                                   pid_t     * pid );
+
+void rpc_process_pid_alloc_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_PROCESS_MIGRATE creates a process descriptor copy, in a remote cluster
+ * and initializes if from information found in the reference process descriptor.
+ * This remote cluster becomes the new reference cluster.
+ * @ cxy     : server cluster identifier.
+ * @ xp_ref  : [in]  extended pointer on reference process descriptor.
+ * @ status  : [out] error status (0 if success).
+ **********************************************************************************/
+void rpc_process_migrate_client( cxy_t       cxy,
+                                 xptr_t      xp_ref,
+                                 error_t   * status );
+
+void rpc_process_migrate_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_VFS_LOOKUP_CHILD returns in the lpr structure information on the
+ * the inode identified by the dentry name and the lkp structure. 
+ * @ cxy     : server cluster identifier
+ * @ lkp     : [in]   pointer on input structure in client cluster
+ * @ name    : [in]   dentry name
+ * @ lpr     : [out]  pointer on output structure in client cluster
+ **********************************************************************************/
+void rpc_vfs_lookup_child_client( cxy_t                    cxy,
+                                  vfs_lookup_t          *  lkp,
+                                  char                  *  name,
+                                  vfs_lookup_response_t *  lpr );
+
+void rpc_vfs_lookup_child_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_THREAD_USER_CREATE creates an user thread in the server cluster,
+ * as specified by the pthread_attr_t argument. It returns an extended pointer
+ * on the thread descriptor in server cluster and an error code.
+ * @ cxy     : server cluster identifier.
+ * @ attr    : [in]   pointer on pthread_attr_t in client cluster.
+ * @ error   : [out] error status (0 if success).
+ * @ thread  : [out] extended pointer on thread descriptor. 
+ **********************************************************************************/
+void rpc_thread_user_create_client( cxy_t             cxy,
+                                    pthread_attr_t *  attr,
+                                    error_t        *  error,
+                                    xptr_t         *  new_thread );
+
+void rpc_thread_user_create_server( xptr_t xp );
+
+
+
+#endif
